//-------------------------------------------------------------
//  Etasoft Inc. Forex EA and Script Generator version 4.1   EA
//-------------------------------------------------------------
// Keywords: MT4, Forex EA builder, create EA, expert advisor developer

#property copyright "Copyright  2011, Etasoft Inc. Forex EA Generator v4.1"
#property link      "http://www.forexgenerator.com/"

#include <stdlib.mqh>
#include <WinUser32.mqh>

// exported variables
extern bool FiveDigitBroker1 = false;
extern bool DetectBrokerDigits1 = true;
extern bool ClearAllObjects1 = false;
extern int OrderType13 = OP_SELL;
extern int OrderId13 = 2;
extern int OrderId15 = 2;
extern int Slippage15 = 1;
extern int Color15 = Red;
extern int OrderType3 = OP_BUY;
extern int OrderId3 = 1;
extern double BuyLots4 = 0.1;
extern int BuySlippage4 = 1;
extern int BuyStoploss4 = 200;
extern int BuyTakeprofit4 = 50;
extern string BuyExpertName4 = "";
extern int BuyOrderId4 = 1;
extern int BuyColor4 = Green;
extern bool ECNBroker4 = false;
extern int OrderType14 = OP_BUY;
extern int OrderId14 = 1;
extern int OrderId16 = 1;
extern int Slippage16 = 1;
extern int Color16 = Green;
extern int OrderType11 = OP_SELL;
extern int OrderId11 = 2;
extern double SellLots12 = 0.1;
extern int SellSlippage12 = 1;
extern int SellStoploss12 = 200;
extern int SellTakeprofit12 = 50;
extern string SellExpertName12 = "";
extern int SellOrderId12 = 2;
extern int SellColor12 = Red;
extern bool ECNBroker12 = false;
extern int OrderId22 = 3;
extern int TrailingStop22 = 15;
extern int NewTakeProfit22 = 100;
extern int Color22 = White;
extern int TrailingGap22 = 7;


// local variables
double PipValue=1;    // this variable is here to support 5-digit brokers
bool Terminated = false;
string LF = "\n";  // use this in custom or utility blocks where you need line feeds
int NDigits = 4;   // used mostly for NormalizeDouble in Flex type blocks
int ObjCount = 0;  // count of all objects created on the chart, allows creation of objects with unique names
int current = 0;

datetime BarTime7 = 0;
datetime BarTime20 = 0;


int init()
{
    NDigits = Digits;
    
    if (ClearAllObjects1) ObjectsDeleteAll();      // clear the chart
    
    
    Comment("");    // clear the chart
}

// Expert start
int start()
{
    if (Bars < 10)
    {
        Comment("Not enough bars");
        return (0);
    }
    if (Terminated == true)
    {
        Comment("EA Terminated.");
        return (0);
    }
    
    OnEveryTick1();
    
}

void OnEveryTick1()
{
    if (DetectBrokerDigits1 == false && FiveDigitBroker1) PipValue = 10;
    if (DetectBrokerDigits1 && (NDigits == 3 || NDigits == 5)) PipValue = 10;
    
    TechnicalAnalysis3x2();
    TechnicalAnalysis3x9();
    TrailingStop22();
    
}

void TechnicalAnalysis3x2()
{
    if ((iCustom(NULL, NULL, "ADX_INDICATOR",48,350,false,true,false,"alert.wav",0,0 - 5) == Low[1]) && (iADX(NULL, NULL,48,PRICE_CLOSE,MODE_PLUSDI,1) > iADX(NULL, NULL,48,PRICE_CLOSE,MODE_MINUSDI,1)) && (iADX(NULL, NULL,48,PRICE_CLOSE,MODE_PLUSDI,0) < iADX(NULL, NULL,48,PRICE_CLOSE,MODE_MINUSDI,0)))
    {
        IfOrderExists13();
        IfOrderDoesNotExist3();
        
    }
}

void IfOrderExists13()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OrderType13 && OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId13)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists)
    {
        CloseOrder15();
        
    }
}

void CloseOrder15()
{
    int orderstotal = OrdersTotal();
    int orders = 0;
    int ordticket[30][2];
    for (int i = 0; i < orderstotal; i++)
    {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderType() != OP_SELL || OrderSymbol() != Symbol() || OrderMagicNumber() != OrderId15)
        {
            continue;
        }
        ordticket[orders][0] = OrderOpenTime();
        ordticket[orders][1] = OrderTicket();
        orders++;
    }
    if (orders > 1)
    {
        ArrayResize(ordticket,orders);
        ArraySort(ordticket);
    }
    for (i = 0; i < orders; i++)
    {
        if (OrderSelect(ordticket[i][1], SELECT_BY_TICKET) == true)
        {
            bool ret = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage15, Color15);
            if (ret == false)
            Print("OrderClose() error - ", ErrorDescription(GetLastError()));
        }
    }
    
}

void IfOrderDoesNotExist3()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OrderType3 && OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId3)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
        OncePerBar7();
        
    }
}

void OncePerBar7()
{
    
    if (BarTime7 < Time[0])
    {
        // we have a new bar opened
        BarTime7 = Time[0]; // keep the new bar open time
        BuyOrder4();
        
    }
}

void BuyOrder4()
{
    double SL = Ask - BuyStoploss4*PipValue*Point;
    if (BuyStoploss4 == 0) SL = 0;
    double TP = Ask + BuyTakeprofit4*PipValue*Point;
    if (BuyTakeprofit4 == 0) TP = 0;
    int ticket = -1;
    if (ECNBroker4)
    ticket = OrderSend(Symbol(), OP_BUY, BuyLots4, Ask, BuySlippage4, 0, 0, BuyExpertName4, BuyOrderId4, 0, BuyColor4);
    else
    ticket = OrderSend(Symbol(), OP_BUY, BuyLots4, Ask, BuySlippage4, SL, TP, BuyExpertName4, BuyOrderId4, 0, BuyColor4);
    if (ticket > -1)
    {
        if (ECNBroker4)
        {
            OrderSelect(ticket, SELECT_BY_TICKET);
            bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), SL, TP, 0, BuyColor4);
            if (ret == false)
            Print("OrderModify() error - ", ErrorDescription(GetLastError()));
        }
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}

void TechnicalAnalysis3x9()
{
    if ((iCustom(NULL, NULL, "ADX_INDICATOR",48,350,false,true,false,"alert.wav",1,0 + 5) == High[1]) && (iADX(NULL, NULL,48,PRICE_CLOSE,MODE_PLUSDI,1) < iADX(NULL, NULL,48,PRICE_CLOSE,MODE_MINUSDI,1)) && (iADX(NULL, NULL,48,PRICE_CLOSE,MODE_PLUSDI,0) > iADX(NULL, NULL,48,PRICE_CLOSE,MODE_MINUSDI,0)))
    {
        IfOrderExists14();
        IfOrderDoesNotExist11();
        
    }
}

void IfOrderExists14()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OrderType14 && OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId14)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists)
    {
        CloseOrder16();
        
    }
}

void CloseOrder16()
{
    int orderstotal = OrdersTotal();
    int orders = 0;
    int ordticket[30][2];
    for (int i = 0; i < orderstotal; i++)
    {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderType() != OP_BUY || OrderSymbol() != Symbol() || OrderMagicNumber() != OrderId16)
        {
            continue;
        }
        ordticket[orders][0] = OrderOpenTime();
        ordticket[orders][1] = OrderTicket();
        orders++;
    }
    if (orders > 1)
    {
        ArrayResize(ordticket,orders);
        ArraySort(ordticket);
    }
    for (i = 0; i < orders; i++)
    {
        if (OrderSelect(ordticket[i][1], SELECT_BY_TICKET) == true)
        {
            bool ret = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage16, Color16);
            if (ret == false)
            Print("OrderClose() error - ", ErrorDescription(GetLastError()));
        }
    }
    
}

void IfOrderDoesNotExist11()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OrderType11 && OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId11)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
        OncePerBar20();
        
    }
}

void OncePerBar20()
{
    
    if (BarTime20 < Time[0])
    {
        // we have a new bar opened
        BarTime20 = Time[0]; // keep the new bar open time
        SellOrder12();
        
    }
}

void SellOrder12()
{
    double SL = Bid + SellStoploss12*PipValue*Point;
    if (SellStoploss12 == 0) SL = 0;
    double TP = Bid - SellTakeprofit12*PipValue*Point;
    if (SellTakeprofit12 == 0) TP = 0;
    int ticket = -1;
    if (ECNBroker12)
    ticket = OrderSend(Symbol(), OP_SELL, SellLots12, Bid, SellSlippage12, 0, 0, SellExpertName12, SellOrderId12, 0, SellColor12);
    else
    ticket = OrderSend(Symbol(), OP_SELL, SellLots12, Bid, SellSlippage12, SL, TP, SellExpertName12, SellOrderId12, 0, SellColor12);
    if (ticket > -1)
    {
        if (ECNBroker12)
        {
            OrderSelect(ticket, SELECT_BY_TICKET);
            bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), SL, TP, 0, SellColor12);
            if (ret == false)
            Print("OrderModify() error - ", ErrorDescription(GetLastError()));
        }
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}

void TrailingStop22()
{
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId22)
        {
            double takeprofit = OrderTakeProfit();
            
            if (OrderType() == OP_BUY && Ask - OrderOpenPrice() > TrailingStop22*PipValue*Point)
            {
                if (OrderStopLoss() < Ask-(TrailingStop22+TrailingGap22)*PipValue*Point)
                {
                    if (NewTakeProfit22 != 0) takeprofit = Ask+(NewTakeProfit22 + TrailingStop22)*PipValue*Point;
                    bool ret1 = OrderModify(OrderTicket(), OrderOpenPrice(), Ask-TrailingStop22*PipValue*Point, takeprofit, OrderExpiration(), Color22);
                    if (ret1 == false)
                    Print("OrderModify() error - ", ErrorDescription(GetLastError()));
                }
            }
            if (OrderType() == OP_SELL && OrderOpenPrice() - Bid > TrailingStop22*PipValue*Point)
            {
                if (OrderStopLoss() > Bid+(TrailingStop22+TrailingGap22)*PipValue*Point)
                {
                    if (NewTakeProfit22 != 0) takeprofit = Bid-(NewTakeProfit22 + TrailingStop22)*PipValue*Point;
                    bool ret2 = OrderModify(OrderTicket(), OrderOpenPrice(), Bid+TrailingStop22*PipValue*Point, takeprofit, OrderExpiration(), Color22);
                    if (ret2 == false)
                    Print("OrderModify() error - ", ErrorDescription(GetLastError()));
                }
            }
        }
    }
    else
    Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    
}



int deinit()
{
    if (ClearAllObjects1) ObjectsDeleteAll();
    
    
}


